//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_facybbs_bss;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Facybbs_Bss extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_facybbs_bss";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Facybbs_Bss() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
      
      
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
            
        test.reset();
        test.terminalProfileSession("1719");
        
        /**********************************************************************/
        /** Testcase 1 . Try to use the findAndCopyValue method with an       */
        /** an destination Buffer null                                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
                
         
        /**********************************************************************/
        /** Testcase 2 . Try to use the findAndCopyValue method with an       */
        /** offset > buffer length                                            */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
                
        
        /**********************************************************************/
        /** Testcase 3 . Try to use the findAndCopyValue method with an       */
        /** offset < 0                                                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
                
        
        /**********************************************************************/
        /** Testcase 4 . Try to use the findAndCopyValue method with an       */
        /** length > buffer length                                            */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
                
        
        /**********************************************************************/
        /** Testcase 5 . Try to use the findAndCopyValue method with an       */
        /** Offset + length > buffer length                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
                
        
        /**********************************************************************/
        /** Testcase 6 . Try to use the findAndCopyValue method with an       */
        /** dstlength < 0                                                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" + 
                        "223344F5 8B214002 81557FF6 00112912" + 
                        "00000413 02700000 0E0D0800 00002001" + 
                        "01000000 00010002 02224433 81C40102" + 
                        "03040506 0708090A 0B0C0D0E 0F101112" + 
                        "13141516 1718191A 1B1C1D1E 1F202122" + 
                        "23242526 2728292A 2B2C2D2E 2F303132" + 
                        "33343536 3738393A 3B3C3D3E 3F404142" + 
                        "43444546 4748494A 4B4C4D4E 4F505152" + 
                        "53545556 5758595A 5B5C5D5E 5F606162" + 
                        "63646566 6768696A 6B6C6D6E 6F707172" + 
                        "73747576 7778797A 7B7C7D7E 7F808182" + 
                        "83848586 8788898A 8B8C8D8E 8F909192" + 
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" + 
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" + 
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" + 
                        "C3C4");                                
        
        
        /**********************************************************************/
        /** Testcase 7 . Try to use the findAndCopyValue method with an       */
        /** ValueOffset > buffer length                                       */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");
        
        /**********************************************************************/
        /** Testcase 8 . Try to use the findAndCopyValue method with an       */
        /** ValueOffset < 0                                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");
        
        /**********************************************************************/
        /** Testcase 9 . Try to use the findAndCopyValue method with an       */
        /** dstLength > Value length                                          */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");
        
        /**********************************************************************/
        /** Testcase 10 . Try to use the findAndCopyValue method with an      */
        /** ValueOffset + dstlength > textstringLength                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");
                        
        /**********************************************************************/
        /** Testcase 11-12 . Try to use the findAndCompareValue method with   */
        /** the researched TAG, Call the getValueLength() method              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");
      
        /**********************************************************************/
        /** Testcase 13 . Try to use the findAndCompareValue method with      */
        /** tag = 06h, occurrence = 1                                         */
        /** valueOffset = 0, dstBuffer.length = 06, dstOffset = 0             */
        /** dstLength = 06                                                    */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");      
        
        /**********************************************************************/
        /** Testcase 14 . Try to use the findAndCompareValue method with      */
        /** buffer = 81 11 22 33 44 F5                                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 15 . Try to use the findAndCompareValue method with      */
        /** buffer = 55 55 55 .... 55 length =12                              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 16 . Try to use the findAndCompareValue method with      */
        /** buffer = 55 55 55 22 33 44 F5 55 55 55 55 55 length =12           */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                      "C3C4");    
        
        /**********************************************************************/
        /** Testcase 17 . Try to use the findAndCompareValue method with      */
        /** successful call                                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 18 . Try to use the findAndCompareValue method with      */
        /** compare buffer                                                    */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 19 . Try to use the findAndCompareValue method with      */
        /** successful call,tag = 02h, occurrence = 2, valueOffset = 0        */
        /** dstBuffer.length = 12, dstOffset = 0, dstLength = 2               */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 20 . Try to use the findAndCompareValue method with      */
        /** successful call                                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 21 . Try to use the findAndCompareValue method with      */
        /** successful call, tag = 82h, occurrence = 1, valueOffset = 0       */
        /** dstBuffer.length = 12, dstOffset = 0, dstLength = 02              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 22 . Try to use the findAndCompareValue method with      */
        /** successful call ,compare buffer                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 23 . Try to use the findAndCompareValue method with      */
        /** successful call, tag = 82h, occurrence = 2, valueOffset = 0       */
        /** dstBuffer.length = 12, dstOffset = 0, dstLength = 02              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 24 . Try to use the findAndCompareValue method with      */
        /** successful call, compare buffer                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /**********************************************************************/
        /** Testcase 25 . Try to use the findAndCompareValue method with      */
        /** successful call, DstBuffer.length = 12, dstOffset = 12            */
        /** dstLength = 0                                                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010002 02224433 81C40102" +
                        "03040506 0708090A 0B0C0D0E 0F101112" +
                        "13141516 1718191A 1B1C1D1E 1F202122" +
                        "23242526 2728292A 2B2C2D2E 2F303132" +
                        "33343536 3738393A 3B3C3D3E 3F404142" +
                        "43444546 4748494A 4B4C4D4E 4F505152" +
                        "53545556 5758595A 5B5C5D5E 5F606162" +
                        "63646566 6768696A 6B6C6D6E 6F707172" +
                        "73747576 7778797A 7B7C7D7E 7F808182" +
                        "83848586 8788898A 8B8C8D8E 8F909192" +
                        "93949596 9798999A 9B9C9D9E 9FA0A1A2" +
                        "A3A4A5A6 A7A8A9AA ABACADAE AFB0B1B2" +
                        "B3B4B5B6 B7B8B9BA BBBCBDBE BFC0C1C2" +
                        "C3C4");    
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData(    "10" + APPLET_AID_1 +
                                        "19CCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                        "CCCCCCCC CCCCCCCC CCCC"));
      
      
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();
        }
}   
