//-----------------------------------------------------------------------------
//Api_2_Ueh_Gsdl_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsdl;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import uicc.usim.toolkit.* ;
import uicc.usim.test.util.* ;

/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getSecuredDataLength()
*/

public class Api_2_Ueh_Gsdl_1  extends TestToolkitApplet
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Gsdl_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Gsdl_1  thisApplet = new Api_2_Ueh_Gsdl_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();  
        
        // Set Formatted SMS PP ENV as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
        // Set Formatted SMS PP UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
          
          // Set Formatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_CB);
          
          // Set Unformatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
          
          // Set Unformatted SMS PP as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        
        // Set Unformatted SMS UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
    
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        
        switch ( testCaseNb ) 
        {
            //=================================================================
            //=========        FORMATTED SMS PP ENV triggering        =========
            //=================================================================
            case (byte) 0 :
            case (byte) 1 :
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 1-3 : getSecuredDataLength with various length of TP-OA:2,6 and 12
    
                bRes = false ;
                testCaseNb++;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x002A)
                        bRes = true ;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 3 :
            case (byte) 4 :
                // --------------------------------------------
                // Test Case 4-5 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
                bRes = false ;
                testCaseNb++;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        
            case (byte) 5 :
                // --------------------------------------------
                // Test Case 6 : getSecuredDataLength with PCNTR = 0 
                testCaseNb = (byte) 6 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            case (byte) 6 :
                // --------------------------------------------
                // Test Case 7 : getSecuredDataLength with PCNTR = 7 
                testCaseNb = (byte) 7 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0003)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 7 :
                // --------------------------------------------
                // Test Case 8 : getSecuredDataLength with length = 0
                testCaseNb = (byte) 8 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0000)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            case (byte) 8 :
                // --------------------------------------------
                // Test Case 9 : secured data length = 0x33 
                testCaseNb = (byte) 9 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0033)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 9 :
                // --------------------------------------------
                // Test Case 10 : getSecuredDataLength with length UDL = 7F
                testCaseNb = (byte) 10 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x006C)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 10 :
                // --------------------------------------------
                // Test Case 11 : getSecuredDataLength with length UDL = 80
                testCaseNb = (byte) 11 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x006D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 11 :
                // --------------------------------------------
                // Test Case 12 : getSecuredDataLength with the maximumlength
                testCaseNb = (byte) 12 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0079)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 12 :
                // --------------------------------------------
                // Test Case 13 : getSecuredDataLength with 2 TPDU TLV
                testCaseNb = (byte) 13 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0005)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 13 :
                // --------------------------------------------
                // Test Case 14 : Concatenated SMS with Secured data length = 0x7F
                testCaseNb = (byte) 14 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x007F)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 14 :
                // --------------------------------------------
                // Test Case 15 : Concatenated SMS with Secured data length = 0x80
                testCaseNb = (byte) 15 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0080)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 15 :
                // --------------------------------------------
                // Test Case 16 : Concatenated SMS with the maximum secured length 
                //                  for 2 envelopes = 0xFA
                testCaseNb = (byte) 16 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x00FA)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 16 :
                // --------------------------------------------
                // Test Case 17 : verify selected TLV; findTLV device Identities
                testCaseNb = (byte) 17 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND) &&
                       (envHdlr.getSecuredDataLength() == (short)0x0005) &&
                        (envHdlr.getValueByte((short)0)==0x40))  
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
    
            //=================================================================
            //=========        FORMATTED SMS PP UPD triggering        =========
            //=================================================================
            case (byte) 17 :
            case (byte) 18 :
            case (byte) 19 :
                // --------------------------------------------
                // Test Case 18-20 : getSecuredDataLength with various length of TP-OA:2,6 and 12
                testCaseNb++;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x002A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        
            case (byte) 20 :
            case (byte) 21 :
                // --------------------------------------------
                // Test Case 21-22 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
                testCaseNb++;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        
            case (byte) 22 :
                // --------------------------------------------
                // Test Case 23 : getSecuredDataLength with PCNTR =0 
                testCaseNb = (byte) 23 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 23 :
                // --------------------------------------------
                // Test Case 24 : getSecuredDataLength with PCNTR = 7 
                testCaseNb = (byte) 24 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0003)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 24 :
                // --------------------------------------------
                // Test Case 25 : getSecuredDataLength with length = 0
                testCaseNb = (byte) 25 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0000)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 25 :
                // --------------------------------------------
                // Test Case 26 : Secured data length = 0x33 
                testCaseNb = (byte) 26 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0033)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 26 :
                // --------------------------------------------
                // Test Case 27 : getSecuredDataLength with length = 7F
                testCaseNb = (byte) 27 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x006C)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 27 :
                // --------------------------------------------
                // Test Case 28 : getSecuredDataLength with length = 80
                testCaseNb = (byte) 28 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x006D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 28 :
                // --------------------------------------------
                // Test Case 29 : getSecuredDataLength with the maximumlength
                testCaseNb = (byte) 29 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0079)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 29 :
                // --------------------------------------------
                // Test Case 30 : getSecuredDataLength with 2 TPDU TLV
                testCaseNb = (byte) 30 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0005)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 30 :
                // --------------------------------------------
                // Test Case 31 : Concatenated SMS with Secured data length = 0x7F
                testCaseNb = (byte) 31 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x007F)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 31 :
                // --------------------------------------------
                // Test Case 32 : Concatenated SMS with Secured data length = 0x80
                testCaseNb = (byte)32 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0080)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 32 :
                // --------------------------------------------
                // Test Case 33 : Concatenated SMS with the maximum secured length 
                //                  for 2 envelopes = 0xFA
                testCaseNb = (byte) 33 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x00FA)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 33 :
                // --------------------------------------------
                // Test Case 34 : verify selected TLV; findTLV device Identities
                testCaseNb = (byte) 34 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getSecuredDataLength() == (short)0x0005)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
    
            //=================================================================
            //=========          FORMATTED SMS CB triggering          =========
            //=================================================================
            case (byte)34 :
            case (byte)35 :
                // --------------------------------------------
                // Test Case 35-36 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
                bRes = false ;
                testCaseNb++;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)36 :
                // --------------------------------------------
                // Test Case 37 : getSecuredDataLength with PCNTR = 0 
                testCaseNb = (byte) 37 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)37 :
                // --------------------------------------------
                // Test Case 38 : getSecuredDataLength with PCNTR = 7 
                testCaseNb = (byte) 38 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0003)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)38 :
                // --------------------------------------------
                // Test Case 39 : getSecuredDataLength with length = 0
                testCaseNb = (byte) 39 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0000)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)39 :
                // --------------------------------------------
                // Test Case 40 : Secured data length = 0x33 
                testCaseNb = (byte) 40 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0033)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)40 :
                // --------------------------------------------
                // Test Case 41 : getSecuredDataLength with the maximumlength
                testCaseNb = (byte) 41 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getSecuredDataLength() == (short)0x0042)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 41 :
                // --------------------------------------------
                // Test Case 42 : findTLV device Identities (Formatted SMS CB envelope)
                testCaseNb = (byte) 42 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getSecuredDataLength() == (short)0x0005)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
    
            //=================================================================
            //=========                  ERROR TESTS                  =========
            //=================================================================
            case (byte) 42:
                // --------------------------------------------
                // Test Case 43 : try to apply the getSecuredDataLength method on an Unformatted SMS CB envelope
                testCaseNb = (byte) 43 ;
    
                bRes = false ;
                try {
                    short returnvalue = envHdlr.getSecuredDataLength();
                }
                catch (uicc.toolkit.ToolkitException e)    {
                    if(e.getReason()== uicc.toolkit.ToolkitException.UNAVAILABLE_ELEMENT ) 
                        bRes = true ;
                    else
                        bRes = false ;
                }
                catch (Exception e)    {    
                        bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 43 :
                // --------------------------------------------
                // Test Case 44 : try to apply the getSecuredDataLength method on an Unformatted SMS PP envelope
                testCaseNb = (byte) 44 ;
    
                bRes = false ;
                try {
                    short returnvalue = envHdlr.getSecuredDataLength();
                }
                catch (uicc.toolkit.ToolkitException e)    {
                    if(e.getReason()== uicc.toolkit.ToolkitException.UNAVAILABLE_ELEMENT ) 
                        bRes = true ;
                    else
                        bRes = false ;
                }
                catch (Exception e)    {    
                        bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        }
    }
}
