//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gudl;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Gudl extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gudl";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gudl() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        addResult(response.checkSw("9000"));
    
        test.reset();
        test.terminalProfileSession("1719");
    
        /*********************************************************************/
        /** Testcase 1. Test with TP-OA length of 2 and User data length =3D */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B4B4002 81557FF6 00112912 0000043D" +
                            "02700000 380D0800 00002001 01000000" +
                            "00010011 22334455 66778899 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30");
        
        
        /**********************************************************************/
        /** Testcase 2. Test with TP-OA length of 12 and RC/CC/DS length is 0 */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B50400C 81334455 6677887F F6001129" +
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202122 23242526 2728292A 2B2C2D2E" +
                            "2F30");
        
        /*********************************************************************/
        /** Testcase 3. Test with RC/CC/DS length of 0 and secured data      */
        /** length = 0x10                                                    */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B314002 81557FF6 00112912 00000423" +
                            "02700000 1E0D0800 00002001 01000000" +
                            "00010001 02030405 06070809 0A0B0C0D" +
                            "0E0F10");
        
        /*********************************************************************/
        /** Testcase 4. Test with RC/CC/DS length of 8 and secured data      */
        /** length = 0x10                                                    */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B394002 81557FF6 00112912 0000042B" +
                            "02700000 26150A02 00112001 01000000" +
                            "00010031 2BFC8086 E1033501 02030405" +
                            "06070809 0A0B0C0D 0E0F10");
        
        /*********************************************************************/
        /** Testcase 5. Send a SMS PP with PCNTR = 0,no RC/CC/DS and data    */
        /** length = 0x10                                                    */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B314002 81557FF6 00112912 00000423" +
                            "02700000 1E0D0800 00002001 01000000" +
                            "00010001 02030405 06070809 0A0B0C0D" +
                            "0E0F10");
        
        /*********************************************************************/
        /** Testcase 6. Send a SMS PP with PCNTR = 7,no RC/CC/DS and data    */
        /** length = 0x03                                                    */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B2E4008 81556677 887FF600 11291200" +
                            "00041D02 70000018 0D0C0011 11200101" +
                            "146DF2FF 4EE31703 89020069 887F6584");
        
        /*********************************************************************/
        /** Testcase 7. Test with SecuredDataLength = 00 and no RC/CC/DS     */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 0100");
          
        /*********************************************************************/
        /** Testcase 8. Test with UserDataLength = 0x7F                      */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819240 0C813344 55667788 7FF60011" +
                            "29120000 047F0270 00007A0D 08000000" +
                            "20010100 00000001 00010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C");  
                            
        /*********************************************************************/
        /** Testcase 9. Test with UserDataLength = 0x80                      */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819340 0C813344 55667788 7FF60011" +
                            "29120000 04800270 00007B0D 08000000" +
                            "20010100 00000001 00010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D");
          
        /*********************************************************************/
        /** Testcase 10. Test with UserDataLength = maximum length (0x8C)    */
        /** for a single SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819F40 0C813344 55667788 7FF60011" +
                            "29120000 048C0270 0000870D 08000000" +
                            "20010100 00000001 00010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "0809");
        
        /*********************************************************************/
        /** Testcase 11. Verify it is the first TPDU TLV:                    */
        /** Send a SMS PP with 2 TPDU TLV with two different user data       */
        /** lengths: 0x18 and 0x23                                           */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 01000102 0304058B 34400881" +
                            "55667788 7FF60011 29120000 04230270" +
                            "0000180D 08000000 20010100 00000001" +
                            "00010203 04050607 08090A0B 0C0D0E0F" +
                            "10");
          
        /*********************************************************************/
        /** Testcase 12. Send envelope SMS-PP Formatted.                     */
        /** FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength()        */
        /** and then getValueByte() with offset 0                            */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 01000102 030405");
          
        /*********************************************************************/
        /** Testcase 13-1. Test with UserDataLength = 0xFF with 2            */ 
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 07000300 02017000 00FA0D08" +
                            "00000020 01010000 00000100 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F20 21222324" +
                            "25262728 292A2B2C 2D2E2F30 31323334" +
                            "35363738 393A3B3C 3D3E3F40 41424344" +
                            "45464748 494A4B4C 4D4E4F50 51525354" +
                            "55565758 595A5B5C 5D5E5F60 61626364" +
                            "65666768 696A6B6C 6D6E6F70 71727374");
        
        /*********************************************************************/
        /** Testcase 13-2. Test with UserDataLength = 0xFF with 2            */ 
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B818F40 08815566 77887FF6 00112912" +
                            "0000047E 05000300 02027576 7778797A" +
                            "7B7C7D7E 7F808182 83848586 8788898A" +
                            "8B8C8D8E 8F909192 93949596 9798999A" +
                            "9B9C9D9E 9FA0A1A2 A3A4A5A6 A7A8A9AA" +
                            "ABACADAE AFB0B1B2 B3B4B5B6 B7B8B9BA" +
                            "BBBCBDBE BFC0C1C2 C3C4C5C6 C7C8C9CA" +
                            "CBCCCDCE CFD0D1D2 D3D4D5D6 D7D8D9DA" +
                            "DBDCDDDE DFE0E1E2 E3E4E5E6 E7E8E9EA" +
                            "EBEC");
        
        
        /*********************************************************************/
        /** Testcase 14-1. Test with UserDataLength = 0x100 with 2           */ 
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 07000300 02017000 00FB0D08" +
                            "00000020 01010000 00000100 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F20 21222324" +
                            "25262728 292A2B2C 2D2E2F30 31323334" +
                            "35363738 393A3B3C 3D3E3F40 41424344" +
                            "45464748 494A4B4C 4D4E4F50 51525354" +
                            "55565758 595A5B5C 5D5E5F60 61626364" +
                            "65666768 696A6B6C 6D6E6F70 71727374");
        
        /*********************************************************************/
        /** Testcase 14-2. Test with UserDataLength = 0x100 with 2           */
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819040 08815566 77887FF6 00112912" +
                            "0000047F 05000300 02027576 7778797A" +
                            "7B7C7D7E 7F808182 83848586 8788898A" +
                            "8B8C8D8E 8F909192 93949596 9798999A" +
                            "9B9C9D9E 9FA0A1A2 A3A4A5A6 A7A8A9AA" +
                            "ABACADAE AFB0B1B2 B3B4B5B6 B7B8B9BA" +
                            "BBBCBDBE BFC0C1C2 C3C4C5C6 C7C8C9CA" +
                            "CBCCCDCE CFD0D1D2 D3D4D5D6 D7D8D9DA" +
                            "DBDCDDDE DFE0E1E2 E3E4E5E6 E7E8E9EA" +
                            "EBECED");
      
        /*********************************************************************/
        /** Testcase 15-1. Test with UserDataLength = 0x10D with 2           */ 
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 07000300 02017000 01080D08" +
                            "00000020 01010000 00000100 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F20 21222324" +
                            "25262728 292A2B2C 2D2E2F30 31323334" +
                            "35363738 393A3B3C 3D3E3F40 41424344" +
                            "45464748 494A4B4C 4D4E4F50 51525354" +
                            "55565758 595A5B5C 5D5E5F60 61626364" +
                            "65666768 696A6B6C 6D6E6F70 71727374");
        
        
        /*********************************************************************/
        /** Testcase 15-2. Test with UserDataLength = 0x10D with 2           */
        /** concatenated SMS                                                 */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 05000300 02027576 7778797A" +
                            "7B7C7D7E 7F808182 83848586 8788898A" +
                            "8B8C8D8E 8F909192 93949596 9798999A" +
                            "9B9C9D9E 9FA0A1A2 A3A4A5A6 A7A8A9AA" +
                            "ABACADAE AFB0B1B2 B3B4B5B6 B7B8B9BA" +
                            "BBBCBDBE BFC0C1C2 C3C4C5C6 C7C8C9CA" +
                            "CBCCCDCE CFD0D1D2 D3D4D5D6 D7D8D9DA" +
                            "DBDCDDDE DFE0E1E2 E3E4E5E6 E7E8E9EA" +
                            "EBECEDEE EFF0F1F2 F3F4F5F6 F7F8F9FA");  
        
        /*********************************************************************/
        /** Testcase 16.  Test with FORMATTED_SMS_PP_UPD and TP-OA length    */
        /** of 2 and user data length of 0x3D                                */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202122 23242526 2728292A 2B2C2D2E" +
                            "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 17.  Test with TP-OA length of 12 and user data length  */ 
        /** of 0x3D                                                          */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0C813344 55667788" +
                            "7FF60011 29120000 043D0270 0000380D" +
                            "08000000 20010100 00000001 00112233" +
                            "44556677 88991011 12131415 16171819" +
                            "1A1B1C1D 1E1F2021 22232425 26272829" +
                            "2A2B2C2D 2E2F30FF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 18.  Test with RC/CC/DS length of 0 and secured data    */
        /** length of 0x10                                                   */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 23027000 001E0D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "11223344 55667788 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 19. Test with RC/CC/DS length of 8 and secured data     */
        /** length of 0x10                                                   */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F" +
                            "F6001129 12000004 2B027000 0026150A" +
                            "02001120 01010000 00000100 70C8F096" +
                            "D32674EE 10111213 14151617 18191A1B" +
                            "1C1D1E1F FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF ");
        
        /*********************************************************************/
        /** Testcase 20.  Test with PCNTR = 0, no RC/CC/DS and data length   */
        /** of 0x10                                                          */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 23027000 001E0D08 00000020" +
                            "01010000 00000100 10111213 14151617" +
                            "18191A1B 1C1D1E1F FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 21.  Test with PCNTR = 7, no RC/CC/DS and data length   */
        /** of 0x05  (use ciphering)                                         */
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 1D027000 00180D0C 00111120" +
                            "0101146D F2FF4EE3 17038902 0069887F" +
                            "6584FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 22. Test with SecuredDataLength = 00 and no RC/CC/DS    */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 13027000 000E0D08 00000020" +
                            "01010000 00000100 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 23. Test with UserDataLength = 0x7F                     */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 7F027000 007A0D08 00000020" +
                            "01010000 00000100 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 24. Test with UserDataLength = 0x80                     */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 80027000 007B0D08 00000020" +
                            "01010000 00000100 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1DFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 25. Test with UserDataLength = maximum length(0x8C)     */ 
        /** for a single SMS                                                 */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F" +
                            "F6001129 12000004 8C027000 00870D08" +
                            "00000020 01010000 00000100 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 191A1B1C 1D1E1F10 11121314" +
                            "15161718 19FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF ");
        
        /*********************************************************************/
        /** Testcase 26. Verify it is the first TPDU TLV:                    */
        /** Send a SMS PP with 2 TPDU TLV with two different user data       */
        /** lengths: 0x18 and 0x23                                           */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 08815566" +
                            "77887FF6 00112912 00000418 02700000" +
                            "130D0800 00002001 01000000 00010001" +
                            "02030405 40088155 6677887F F6001129" +
                            "12000004 23027000 00180D08 00000028" +
                            "81850000 00000100 01020304 05060708" +
                            "090A0B0C 0D0E0F10 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 27. Send envelope SMS-PP Formatted.                     */
        /** FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength() and    */ 
        /** then getValueByte() with offset 0                                */               
        /*********************************************************************/      
        
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 18027000 00130D08 00000020" +
                            "01010000 00000100 01020304 05FFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        /*********************************************************************/
        /** Testcase 28-1.Test with UserDataLength = 0xFF with 2             */
        /** concatenated SMS                                                 */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C070003 00020170 0000FA0D" +
                            "08000000 20010100 00000001 00010203" +
                            "04050607 08090A0B 0C0D0E0F 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30313233" +
                            "34353637 38393A3B 3C3D3E3F 40414243" +
                            "44454647 48494A4B 4C4D4E4F 50515253" +
                            "54555657 58595A5B 5C5D5E5F 60616263" +
                            "64656667 68696A6B 6C6D6E6F 70717273" +
                            "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 28-2.Test with UserDataLength = 0xFF with 2             */
        /** concatenated SMS                                                 */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 7E050003 00020275 76777879" +
                            "7A7B7C7D 7E7F8081 82838485 86878889" +
                            "8A8B8C8D 8E8F9091 92939495 96979899" +
                            "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                            "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                            "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                            "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                            "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                            "EAEBECFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 29-1.Test with UserDataLength = 0x100 with 2             */
        /** concatenated SMS                                                  */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C070003 00020170 0000FB0D" +
                            "08000000 20010100 00000001 00010203" +
                            "04050607 08090A0B 0C0D0E0F 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30313233" +
                            "34353637 38393A3B 3C3D3E3F 40414243" +
                            "44454647 48494A4B 4C4D4E4F 50515253" +
                            "54555657 58595A5B 5C5D5E5F 60616263" +
                            "64656667 68696A6B 6C6D6E6F 70717273" +
                            "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
                                        
        /*********************************************************************/
        /** Testcase 29-2.Test with UserDataLength = 0x100 with 2             */
        /** concatenated SMS                                                  */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 7F050003 00020275 76777879" +
                            "7A7B7C7D 7E7F8081 82838485 86878889" +
                            "8A8B8C8D 8E8F9091 92939495 96979899" +
                            "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                            "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                            "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                            "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                            "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                            "EAEBECED FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 30-1.Test with UserDataLength = 0x10D with 2             */
        /** concatenated SMS                                                  */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C070003 00020170 0001080D" +
                            "08000000 20010100 00000001 00010203" +
                            "04050607 08090A0B 0C0D0E0F 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30313233" +
                            "34353637 38393A3B 3C3D3E3F 40414243" +
                            "44454647 48494A4B 4C4D4E4F 50515253" +
                            "54555657 58595A5B 5C5D5E5F 60616263" +
                            "64656667 68696A6B 6C6D6E6F 70717273" +
                            "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
                            
        /*********************************************************************/
        /** Testcase 30-2.Test with UserDataLength = 0x10D with 2             */
        /** concatenated SMS                                                  */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C050003 00020275 76777879" +
                            "7A7B7C7D 7E7F8081 82838485 86878889" +
                            "8A8B8C8D 8E8F9091 92939495 96979899" +
                            "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                            "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                            "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                            "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                            "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                            "EAEBECED EEEFF0F1 F2F3F4F5 F6F7F8F9" +
                            "FAFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
                            
        /*********************************************************************/
        /** Testcase 31. Test with UNFORMATTED_SMS_PP_ENV and TP-OA length   */
        /** of 2, and user data length of 0x3D                               */
        /*********************************************************************/         
        
        test.sendApdu(  "80C20000 5AD15882 02838106 05801122" +
                        "33448B4B 00028155 7FF60011 29120000" +
                        "043D0102 03040506 0708090A 0B0C0D0E" +
                        "0F101112 13141516 1718191A 1B1C1D1E" +
                        "1F202122 23242526 2728292A 2B2C2D2E" +
                        "2F303132 33343536 3738393A 3B3C3D");
        
        /*********************************************************************/
        /** Testcase 32. Test with UNFORMATTED_SMS_PP_ENV and TP-OA length   */
        /** of 12, and user data length of 0x3D                              */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B50000C81 33445566 77887FF6 00112912" +
                            "0000043D 11223344 55667788 99101112" +
                            "13141516 1718191A 1B1C1D1E 1F202122" +
                            "23242526 2728292A 2B2C2D2E 2F303132" +
                            "33343536 3738393A 3B3C3D3E 3F404142" +
                            "43");
        
        /*********************************************************************/
        /** Testcase 33. Test with UNFORMATTED_SMS_PP_ENV and user data      */
        /** length of 0x00                                                   */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B13000C81 33445566 77887FF6 00112912" +
                            "00000400");
        
        /*********************************************************************/
        /** Testcase 34. Test with UNFORMATTED_SMS_PP_ENV and user data      */
        /** length of 0x7F                                                   */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B819200 0C813344 55667788 7FF60011" +
                            "29120000 047F0102 03040506 0708090A" +
                            "0B0C0D0E 0F101112 13141516 1718191A" +
                            "1B1C1D1E 1F202122 23242526 2728292A" +
                            "2B2C2D2E 2F303132 33343536 3738393A" +
                            "3B3C3D3E 3F404142 43444546 4748494A" +
                            "4B4C4D4E 4F505152 53545556 5758595A" +
                            "5B5C5D5E 5F606162 63646566 6768696A" +
                            "6B6C6D6E 6F707172 73747576 7778797A" +
                            "7B7C7D7E 7F");
        
        /*********************************************************************/
        /** Testcase 35. Test with UNFORMATTED_SMS_PP_ENV and user data      */
        /** length of 0x80                                                   */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B819300 0C813344 55667788 7FF60011" +
                            "29120000 04800102 03040506 0708090A" +
                            "0B0C0D0E 0F101112 13141516 1718191A" +
                            "1B1C1D1E 1F202122 23242526 2728292A" +
                            "2B2C2D2E 2F303132 33343536 3738393A" +
                            "3B3C3D3E 3F404142 43444546 4748494A" +
                            "4B4C4D4E 4F505152 53545556 5758595A" +
                            "5B5C5D5E 5F606162 63646566 6768696A" +
                            "6B6C6D6E 6F707172 73747576 7778797A" +
                            "7B7C7D7E 7F80");
        
        /*********************************************************************/
        /** Testcase 36. Test with UNFORMATTED_SMS_PP_ENV and user data      */
        /** length of 0x8C                                                   */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B819F00 0C813344 55667788 7FF60011" +
                            "29120000 048C0102 03040506 0708090A" +
                            "0B0C0D0E 0F101112 13141516 1718191A" +
                            "1B1C1D1E 1F202122 23242526 2728292A" +
                            "2B2C2D2E 2F303132 33343536 3738393A" +
                            "3B3C3D3E 3F404142 43444546 4748494A" +
                            "4B4C4D4E 4F505152 53545556 5758595A" +
                            "5B5C5D5E 5F606162 63646566 6768696A" +
                            "6B6C6D6E 6F707172 73747576 7778797A" +
                            "7B7C7D7E 7F808182 83848586 8788898A" +
                            "8B8C");
        
        /*********************************************************************/
        /** Testcase 37. Verify it is the first TPDU TLV:                    */
        /** Send a SMS PP with 2 TPDU TLV with two different user data       */
        /** lengths: 0x18 and 0x23                                           */
        /*********************************************************************/         
        
        test.envelopeSmsPp( "8B290008 81556677 887FF600 11291200" +
                            "00041801 02030405 06070809 0A0B0C0D" +
                            "0E0F1011 12131415 1617188B 34000881" +
                            "55667788 7FF60011 29120000 04230102" +
                            "03040506 0708090A 0B0C0D0E 0F101112" +
                            "13141516 1718191A 1B1C1D1E 1F202122" +
                            "23");
        
        /*********************************************************************/
        /** Testcase 38. Send envelope SMS-PP Unformatted.                   */
        /** FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength()        */
        /** and then getValueByte() with offset 0 (first user data = 0x55)   */
        /*********************************************************************/         
    
        test.sendApdu(  "80C20000 38D13682 02838106 05801122" +
                        "33448B29 00088155 6677887F F6001129" +
                        "12000004 18010203 04050607 08090A0B" +
                        "0C0D0E0F 10111213 14151617 18");
        /*********************************************************************/
        /** Testcase 39.  Test with UNFORMATTED_SMS_PP_UPD and TP-OA length  */
        /** of 2 and user data length of 0x3D                                */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F" +
                            "F6001129 12000004 3D010203 04050607" +
                            "08090A0B 0C0D0E0F 10111213 14151617" +
                            "18191A1B 1C1D1E1F 20212223 24252627" +
                            "28292A2B 2C2D2E2F 30313233 34353637" +
                            "38393A3B 3C3DFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 40.  Test with UNFORMATTED_SMS_UPD and TP-OA length     */  
        /** of 12 and user data length of 0x3D                               */                                      
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0C813344 5566" +
                            "77887FF6 00112912 0000043D 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F20 21222324" +
                            "25262728 292A2B2C 2D2E2F30 31323334" +
                            "35363738 393A3B3C 3DFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFF");
        
        /*********************************************************************/
        /** Testcase 41.  Test with UNFORMATTED_SMS_UPD and TP-OA length     */  
        /** of 12 and user data length of 0x00                               */                                      
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 00FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 42.  Test with UNFORMATTED_SMS_UPD and TP-OA length     */  
        /** of 12 and user data length of 0x7F                               */                                      
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 7F010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 20212223 24252627 28292A2B" +
                            "2C2D2E2F 30313233 34353637 38393A3B" +
                            "3C3D3E3F 40414243 44454647 48494A4B" +
                            "4C4D4E4F 50515253 54555657 58595A5B" +
                            "5C5D5E5F 60616263 64656667 68696A6B" +
                            "6C6D6E6F 70717273 74757677 78797A7B" +
                            "7C7D7E7F FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 43.  Test with UNFORMATTED_SMS_UPD and TP-OA length     */  
        /** of 12 and user data length of 0x80                               */                       
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 80010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 20212223 24252627 28292A2B" +
                            "2C2D2E2F 30313233 34353637 38393A3B" +
                            "3C3D3E3F 40414243 44454647 48494A4B" +
                            "4C4D4E4F 50515253 54555657 58595A5B" +
                            "5C5D5E5F 60616263 64656667 68696A6B" +
                            "6C6D6E6F 70717273 74757677 78797A7B" +
                            "7C7D7E7F 80FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 44.  Test with UNFORMATTED_SMS_UPD and TP-OA length     */  
        /** of 12 and user data length of 0x8C                               */                                      
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 8C010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 20212223 24252627 28292A2B" +
                            "2C2D2E2F 30313233 34353637 38393A3B" +
                            "3C3D3E3F 40414243 44454647 48494A4B" +
                            "4C4D4E4F 50515253 54555657 58595A5B" +
                            "5C5D5E5F 60616263 64656667 68696A6B" +
                            "6C6D6E6F 70717273 74757677 78797A7B" +
                            "7C7D7E7F 80818283 84858687 88898A8B" +
                            "8CFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
          
        /*********************************************************************/
        /** Testcase 45. Verify it is the first TPDU TLV:                    */
        /** Send a UNFORMATTED SMS UPD with 2 TPDU TLV with two different    */
        /** lengths: 0x18 and 0x23                                           */               
        /*********************************************************************/      
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 08815566 77887FF6" +
                            "00112912 00000418 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "00088155 6677887F F6001129 12000004" +
                            "23010203 04050607 08090A0B 0C0D0E0F" +
                            "10111213 14151617 18191A1B 1C1D1E1F" +
                            "20212223 FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        /*********************************************************************/
        /** Testcase 46. Send envelope SMS-UPD UNFORMATTED                   */
        /** FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength() and    */ 
        /** then getValueByte() with offset 0                                */               
        /*********************************************************************/      
        // select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        //update first record
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 18010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18FFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        
        /*********************************************************************/
        /** Testcase 47 Send an Unrecognized Envelope                        */
        /*********************************************************************/         
        // Trigger applet
        
        test.unrecognizedEnvelope();
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "2FCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();
    }
}   
