//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gvle;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Gvle extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gvle";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gvle() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "07" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        addResult(response.checkSw("9000"));
          
        test.reset();
        test.terminalProfileSession("1719");

        /**********************************************************************/
        /** Testcase 1. try to use the getValueLength method without current  */
        /** TLV                                                               */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 2. search the TAG 02 and use the method                  */
        /** getValueLength =02                                                */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 3. search the TAG 0B and use the method                  */
        /**  getValueLength =0x24                                             */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 4. search the TAG 0x33 and use the method                */
        /** getValueLength =0x00C8                                            */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
          
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "04CCCCCC CC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
      
        return getOverallResult();
    }
}   
