//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//----------------------------------------------------------------------------- 
package uicc.usim.test.usatframework.ufw_mha_rent;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.toolkit.*;
import uicc.usim.test.util.* ;


public class Ufw_Mha_Rent_1 extends TestToolkitApplet {
  
    /** result of specific testcase */
    boolean           bRes        = false;
    /** number of testcase */
    byte            testCaseNb      = (byte) 0x00;

    private byte[] TEXT = {(byte)'T',(byte)'E',(byte)'X',(byte)'T',(byte)' ',(byte)'1'};    
    
    private final short     eventList[] = { 
                      EVENT_UNRECOGNIZED_ENVELOPE,
                      EVENT_FORMATTED_SMS_PP_UPD,
                      EVENT_UNFORMATTED_SMS_PP_UPD,
                      EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,
                      EVENT_FORMATTED_SMS_PP_ENV,
                      EVENT_UNFORMATTED_SMS_PP_ENV,
                      EVENT_FORMATTED_SMS_CB,
                      EVENT_UNFORMATTED_SMS_CB};                   
                      

    /**
     */
    private Ufw_Mha_Rent_1 () {
    } 
  

    public static void install(byte[] bArray, short bOffset, byte bLength) {
 
         
        // Create a new applet instance.
        Ufw_Mha_Rent_1 thisApplet = new Ufw_Mha_Rent_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
              
        //- Applet registration     
        thisApplet.obReg.setEventList(thisApplet.eventList,(short)0,(short)(thisApplet.eventList.length));
    }
  
    public void processToolkit(short event) throws ToolkitException {
        bRes=false;
      
        switch(event){ 
              
            case EVENT_UNRECOGNIZED_ENVELOPE:
                try {
                        ProactiveHandler prHdlr = ProactiveHandlerSystem.getTheHandler();                 
                        prHdlr.initDisplayText((byte)0x80,(byte)0x04,TEXT,(short)0,(short)TEXT.length);
                        prHdlr.send();                        
                }
                catch(Exception exp) {                    
                }          
                break;
            // Test case 1 
            case EVENT_FORMATTED_SMS_PP_UPD:
            
                testCaseNb=(byte)0x01;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x02;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x03;              
                //EnvelopeResponseHandler is not available
                getEnvelopeResponseHandlerNotAvailableException(testCaseNb);                
                break;              
            // Test case 2
            case EVENT_UNFORMATTED_SMS_PP_UPD:
            
                testCaseNb=(byte)0x04;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x05;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x06;              
                //EnvelopeResponseHandler is not available
                getEnvelopeResponseHandlerNotAvailableException(testCaseNb);          
                break;                              
            // Test case 3
            case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM:

                testCaseNb=(byte)0x07;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x08;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x09;              
                //EnvelopeResponseHandler is available
                getEnvelopeResponseHandler(testCaseNb);          
                break;                
            // Test case 4
            case EVENT_FORMATTED_SMS_PP_ENV:

                testCaseNb=(byte)0x0A;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x0B;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x0C;              
                //EnvelopeResponseHandler is available
                getEnvelopeResponseHandler(testCaseNb);         
                break; 
            // Test case 5
            case EVENT_UNFORMATTED_SMS_PP_ENV:
                
                testCaseNb=(byte)0x0D;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x0E;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x0F;              
                //EnvelopeResponseHandler is available
                getEnvelopeResponseHandler(testCaseNb);           
                break;                   
            // Test case 6 
            case EVENT_FORMATTED_SMS_CB:
            
                testCaseNb=(byte)0x10;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x11;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x12;              
                //EnvelopeResponseHandler is not available
                getEnvelopeResponseHandlerNotAvailableException(testCaseNb);                
                break;              
            // Test case 7
            case EVENT_UNFORMATTED_SMS_CB:
            
                testCaseNb=(byte)0x13;               
                //EnvelopeHandler is available
                getEnvelopeHandler(testCaseNb);
                testCaseNb=(byte)0x14;
                //USATEnvelopeHandler is available
                getUSATEnvelopeHandler(testCaseNb);  
                testCaseNb=(byte)0x15;              
                //EnvelopeResponseHandler is not available
                getEnvelopeResponseHandlerNotAvailableException(testCaseNb);          
                break;                            
      }
    }
    
    /**
     * Method test if a instance of the EnvelopeHandler class can be 
     * successful instantiated. If so the test case will be reported as
     * successful. Otherwise as failure.
     * 
     * @param testCaseNb number of the current test case
     */ 
    private void getEnvelopeHandler(byte testCaseNb) {
      bRes=false;
      try {
        //get the Envelope Handler
        EnvelopeHandler enHdr = EnvelopeHandlerSystem.getTheHandler();
        bRes=true;
      }
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }

    /**
     * Method test if a instance of the USATEnvelopeHandler class can be 
     * successful instantiated. If so the test case will be reported as
     * successful. Otherwise as failure.
     * 
     * @param testCaseNb number of the current test case
     */ 
    private void getUSATEnvelopeHandler(byte testCaseNb) {
      bRes=false;
      try {
        //get the USAT Envelope Handler
        USATEnvelopeHandler uenHdr = USATEnvelopeHandlerSystem.getTheHandler();
        bRes=true;
      }
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }
  
    /**
     * Method test if a instance of the EnvelopeResponseHandler class can be 
     * successful instantiated. If so the test case will be reported as
     * successful. Otherwise as failure.
     * 
     * @param testCaseNb number of the current test case
     */ 
    private void getEnvelopeResponseHandler(byte testCaseNb) {
      bRes=false;
      try {
        //get the Envelope Response Handler
        EnvelopeResponseHandler enresHdr = EnvelopeResponseHandlerSystem.getTheHandler();
        bRes=true;
      }      
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }

    /**
     * Methods try to get a instance of the EnvelopeResponseHandler class. If this
     * fails and a ToolkitException.HANDLER_NOT_AVAILABLE is thrown, the test
     * case will be reported as successful. Otherwise as failure.
     * 
     * @param testCaseNb Number of the current test case
     */
    private void getEnvelopeResponseHandlerNotAvailableException(byte testCaseNb) {
      bRes=false;
      try {
        //get the Envelope Response Handler
        EnvelopeResponseHandler enresHdr = EnvelopeResponseHandlerSystem.getTheHandler();
      }
      catch (ToolkitException e) {
        if (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE) {
          bRes=true;
        }
      }
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }    
    
    
    
    
}